n=2000; % number of nodes in the network
epsilon=0.1; % parameter of SBM, cout/cin
c=3; % average degree
seed=1; % seed of random number generator
learning_rate = 10; % speed of learning
threshold = 5/n; % when the IPR < threshold, learning is complete.

[E,A,conf_true] = gen_SBM_with_cliques( n,c,2,epsilon,seed ); % generate a SBM with 10 cliques
[V,D]=eigs(A,2,'la');
accu_A=compute_accurarcy(V,conf_true); % compute the accuracy of reconstruction. 
%for 2 groups, accuracy ranges from 0.5 to 1. Where a random partition gives
%accurarcy 0.5, and the true partition gives accurarcy 1.
fprintf('Accurarcy of the adjacency matrix is %g\n',accu_A(2));
ipr=sum(V.^4);
Lx=A; % initialize the X-Laplacian
q=3; % finding 3 eigengectors
for i=1:500
    [~,idx]=max(ipr);
    v=V(:,idx);
    Lx(logical(speye(size(Lx))))=Lx(logical(speye(size(Lx))))-v.^2*learning_rate; % learing the regularization using the localized eigenvectors.
    [V,D,flag] = eigs(Lx,q,'la');
    D=sum(D);
    ipr=sum(V.^4);
    accu=compute_accurarcy(V,conf_true);
    fprintf('#%g ipr=%g %g %g, accuracy=%g\n',i, ipr(1),ipr(2), ipr(3),accu(2));
    if( ipr(2) < threshold) % when the informative IPR  < threshold, learning is complete.
        break;
    end
end
fprintf('Accurarcy of the adjacency matrix is %g\n',accu_A(2));
accu=compute_accurarcy(V,conf_true); % compute the accuracy of reconstruction
fprintf('Accurarcy of the X-Laplacian is %g\n',accu(2)); % The first eigenvector is ferromagnetic, we should use the second eigenvector.